<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\goods_time;


use app\common\model\goods_time\GoodsTime;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * GoodsTime逻辑
 * Class GoodsTimeLogic
 * @package app\adminapi\logic\goods_time
 */
class GoodsTimeLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public static function add(array $params): bool
    {
        if($params['goods_category_ids']){
            foreach ($params['goods_category_ids'] as $val){
                is_array($val)?($ids[] = end($val)):($ids[] = $val);
            }
            $params['goods_category_ids'] = implode(',',$ids);
        }
        Db::startTrans();
        try {
            GoodsTime::create([
                'title' => $params['title'],
                'service_time' => $params['service_time'],
                'goods_category_ids' => $params['goods_category_ids'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public static function edit(array $params): bool
    {
        if($params['goods_category_ids']){
            foreach ($params['goods_category_ids'] as $val){
                is_array($val)?($ids[] = end($val)):($ids[] = $val);
            }
            $params['goods_category_ids'] = implode(',',$ids);
        }
        Db::startTrans();
        try {
            GoodsTime::where('id', $params['id'])->update([
                'title' => $params['title'],
                'service_time' => $params['service_time'],
                'goods_category_ids' => $params['goods_category_ids'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public static function delete(array $params): bool
    {
        return GoodsTime::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public static function detail($params): array
    {
        $info = GoodsTime::findOrEmpty($params['id'])->toArray();
        if(!empty($info['goods_category_ids'])){
            $info['goods_category_ids'] = explode(',',$info['goods_category_ids']);
            $info['goods_category_ids'] = array_map('intval', $info['goods_category_ids']);
        }
        return $info;
    }
}